Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 1596)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 1604)
@@ -115,5 +115,5 @@
 mCurrentAlgorithm(GtpVisibility::VisibilityEnvironment::COHERENT_HIERARCHICAL_CULLING),
 mNodeVizMode(NODEVIZ_NONE),
-mVizCameraHeight(Real(4000.0)),
+mVizCameraHeight(Real(2000.0)),
 mCamNode(camNode),
 mAppState(WALKTHROUGH),
@@ -128,4 +128,5 @@
 mRMouseDown(false),
 mShowOctree(false),
+mShowViewCells(false),
 mUseDepthPass(false),
 mTestGeometryForVisibleLeaves(false),
@@ -243,4 +244,5 @@
 	
 	mSceneMgr->setOption("ShowOctree", &mShowOctree);
+	mSceneMgr->setOption("ShowViewCells", &mShowViewCells);
 	mSceneMgr->setOption("CullCamera", &mCullCamera);
 	mSceneMgr->setOption("PrepareVisualization", &mShowVisualization);
@@ -444,9 +446,12 @@
 	}
 
-	//-- set parameters for visualization
 	if (mShowVisualization)
 	{
+		////////////////
+		//-- set parameters for visualization
+
 		// important for visualization => draw octree bounding boxes
-		//mSceneMgr->setOption("ShowOctree", &mShowVisualization);
+		if (0)
+			mSceneMgr->setOption("ShowOctree", &mShowVisualization);
 		
 		///////////////
@@ -466,6 +471,7 @@
 			-mCamera->getDerivedDirection().z));
 		
+		const float moveFactor = 200;
 		// move by a constant so view plane is on bottom of viewport
-		mVizCamera->moveRelative(Vector3(0, 800, 0));
+		mVizCamera->moveRelative(Vector3(0, moveFactor, 0));
 	}
 	else
@@ -1185,4 +1191,10 @@
 	mShowOctree = !mShowOctree;
 	mSceneMgr->setOption("ShowOctree", &mShowOctree);
+}
+//-----------------------------------------------------------------------
+void TerrainFrameListener::toggleShowViewCells()
+{
+	mShowViewCells = !mShowViewCells;
+	mSceneMgr->setOption("ShowViewCells", &mShowViewCells);
 }
 //-----------------------------------------------------------------------
@@ -1363,10 +1375,12 @@
 
 	case KC_C:
-
 		if (mItemBufferMode != GtpVisibility::QueryManager::GEOMETRY_VISIBILITY)
+		{
 			mItemBufferMode = GtpVisibility::QueryManager::GEOMETRY_VISIBILITY;
+		}
 		else
+		{
 			mItemBufferMode = GtpVisibility::QueryManager::PATCH_VISIBILITY;
-
+		}
 		break;
 
@@ -1378,4 +1392,5 @@
 		break;
 
+	///////////////
 	//-- visualization
 	case KC_1:
@@ -1396,5 +1411,5 @@
 		toggleRecord();
 		break;
-#if USE_PERFHUD
+//#if USE_PERFHUD
 	case KC_F1:
 		toggleShowHelp();
@@ -1413,7 +1428,11 @@
 		applyObjectType();
 		break;
-	#endif
+//#endif
+
 	case KC_F8:
-		mApplication->generateScene(500, mCurrentObjectType);
+		{	// generate new objects
+			const int objNum = 500;
+			mApplication->generateScene(objNum, mCurrentObjectType);
+		}
 		break;
 	case KC_F9:
@@ -1432,9 +1451,9 @@
 	case KC_8:
 		changeAssumedVisibility(-5);
-	//	changeAssumedVisibility(-500);
+		// changeAssumedVisibility(-500);
 		break;
 	case KC_9:
-	//	changeAssumedVisibility(500);
 		changeAssumedVisibility(5);
+		// changeAssumedVisibility(500);
 		break;
 	case KC_LSHIFT:
@@ -1455,4 +1474,7 @@
 	case KC_V:
 		toggleUseViewCells();
+		break;
+	case KC_L:
+		toggleShowViewCells();
 		break;
 	case KC_Q:
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 1593)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 1604)
@@ -239,4 +239,9 @@
 				 GtpVisibility::VisibilityEnvironment::FRUSTUM_CULLING;
 		 }
+		 else // default rendering
+		 {
+			 mAlgorithm = 
+				 GtpVisibility::VisibilityEnvironment::NUM_CULLING_MANAGERS;
+		 }
 	}
 
@@ -289,5 +294,7 @@
 	mCamNode->attachObject(mCamera);
 	
+	///////////////////
 	//-- create visualization camera
+
 	mVizCamera = mSceneMgr->createCamera("VizCam");
 	mVizCamera->setPosition(mCamNode->getPosition());
@@ -700,16 +707,9 @@
 		if (rit->movable->getName() != "PlayerCam")
 		{
-			mCamNode->setPosition(mCamNode->getPosition().x,
+			mCamNode->setPosition(
+				mCamNode->getPosition().x,
 				rit->movable->getWorldBoundingBox().getCenter().y + 2, 
 				mCamNode->getPosition().z);
 	
-			/*
-			std::stringstream d;
-			d << "World: " << it->movable->getWorldBoundingBox().getCenter().y <<
-			", Object: " << it->movable->getBoundingBox().getCenter().y <<
-			", Camera: " << mCamera->getDerivedPosition();
-
-			LogManager::getSingleton().logMessage(d.str());*/
-
 			return true;
 		}
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 1271)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 1604)
@@ -210,7 +210,10 @@
 	void changeVizScale(const int incr);
 	void setTestGeometryForVisibleLeaves(bool testGeometryForVisibleLeaves);
-	/** Shows octree hierarchy of the scene.
+	/** Shows visualization of octree hierarchy nodes.
 	*/
 	void toggleShowOctree();
+	/** Shows visualization of the view cells.
+	*/
+	void toggleShowViewCells();
 	/** Toggles between view cells / no view cells.
 	*/
@@ -353,4 +356,5 @@
 	bool mTestGeometryForVisibleLeaves;
 	bool mShowOctree;
+	bool mShowViewCells;
 	bool mUseDepthPass;
 	bool mShowVisualization;
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 1271)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 1604)
@@ -29,4 +29,5 @@
 {
 public:
+	
 	VisualizationRenderTargetListener(SceneManager *sceneMgr);
 