Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material	(revision 1590)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material	(revision 1611)
@@ -192,5 +192,5 @@
 				texture talaj.jpg
 				tex_coord_set 0
-				colour_op modulate
+				colour_op replace
 				
 
@@ -207,6 +207,6 @@
 			cull_hardware none
 
-			ambient 1 0.408055 0.07 0.79488
-			diffuse 1 0.408055 0.07 0.79488
+			ambient 1 0.408055 0.07 0.9
+			diffuse 1 0.408055 0.07 0.9
 			specular 0 0 0 0
 			emissive 0.3 0.15 0.03
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Ogre.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Ogre.material	(revision 777)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Ogre.material	(revision 1611)
@@ -48,6 +48,6 @@
 			{
 				texture dirt01.jpg
-				colour_op_ex add src_texture src_current
-				colour_op_multipass_fallback one one
+				//colour_op_ex add src_texture src_current
+				//colour_op_multipass_fallback one one
 			}
 		}
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material	(revision 1590)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material	(revision 1611)
@@ -51,6 +51,6 @@
 	        param_named_auto height viewport_height
 		//param_named cutValue float 10.0
-		param_named cutValue float 10.0
-		param_named timeBlur float 0.4
+		param_named cutValue float 10.5
+		param_named timeBlur float 0.5
 	        
          }
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl	(revision 1598)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl	(revision 1611)
@@ -60,5 +60,5 @@
     float3 pos = IN.wPos;
     
-    float M = 4;
+    float M = 1;
    
     float3 lightpositions[8];
@@ -92,5 +92,5 @@
 	L = normalize(L);
 	float3 H = normalize(L + V);
-	float lightscale = 3;
+	float lightscale = 1.0;
 	float4 spec = specular * lightcolors[i] * pow(dot(H, N), shininess) * lightscale;
 	float4 diff = diffuse * lightcolors[i] * abs(dot(L, N)) * lightscale;
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 1598)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 1611)
@@ -24,5 +24,4 @@
 */
 
-
 #include "ExampleApplication.h"
 #include "OgreIlluminationManager.h"
@@ -30,5 +29,5 @@
 float causize = 10;
 float cauintens = 40;
-
+int scene = 1;
 // Listener class for frame updates
 class RaytraceDemoListener : public ExampleFrameListener
@@ -321,5 +320,5 @@
     {
 
-	//	createPostproc();
+		//createPostproc();
 		
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
@@ -335,5 +334,7 @@
 		mCamera->setNearClipDistance(0.1);
 		
-		//createScene1();
+		if(scene == 1)
+		createScene1();
+		else
 		createScene2();
 		
@@ -355,11 +356,12 @@
 		SceneNode* rootNode = mSceneMgr->getRootSceneNode();
 
-      	Entity* object = mSceneMgr->createEntity("object", "athene.mesh");
+      	Entity* object = mSceneMgr->createEntity("object", "chinaman.mesh");
 		object->setMaterialName("GameTools/Diffuse/use");
 		//object->setMaterialName("GameTools/Diffuse2");
 		objectNode = rootNode->createChildSceneNode();
 		objectNode->attachObject(object);
-		objectNode->scale(0.05,0.05,0.05);
-		objectNode->setPosition(0,4,0);
+	//	objectNode->scale(0.05,0.05,0.05);
+		objectNode->scale(3,3,3);
+	//	objectNode->setPosition(0,4,0);			
 		objectNode->_updateBounds();
 
@@ -591,4 +593,5 @@
         mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
 		mRoot->addFrameListener(mFrameListener);
+		if(scene == 2)
 		mRoot->addFrameListener(reflListener);
 	